
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;






//-------------------------------------------------------------
//begin implementing GUI 
//-------------------------------------------------------------
class CreateButton {
   private static ButtonListener bl = new ButtonListener();
   public static Button makeButton( String num ) {
      Button btn = new Button( num );          // 1. Identify intrinsic state
      btn.addActionListener( bl );
      return btn;                              // 2. Return a new object
   }
}

class ButtonListener implements ActionListener {
   @Override
   public void actionPerformed( ActionEvent e) {
      Button      btn  = (Button) e.getSource();
      Component[] btns = btn.getParent().getComponents();
      float stuff[] = new float[500];
      int i = 0;
      for ( ; i < btns.length; i++)
         if (btn == btns[i]) break;
      // 4. A third party must compute the extrinsic state (x and y)
      //    (the Button label is intrinsic state)
      NetworkObserverSubject.S.setState(Integer.parseInt(e.getActionCommand()));
   }  
}


public class NetworkObserverDemo{
   public static final int NUMrow = 20;
   public static final int NUMcol = 15;
   

   
   public static void main( String[] args ) {
      Frame frame = new Frame( "Flyweight Demo" );
      frame.setLayout( new GridLayout( NUMrow, NUMcol ) );
      int num = 1;
      for (int i=0; i < NUMrow; i++)
         for (int j=0; j < NUMcol; j++)
            frame.add( CreateButton.makeButton( 
               Integer.toString( num++ ) ) );
      frame.pack();
      frame.setVisible( true );
   }  
}
